#!/usr/bin/python

import socket, time
import signal

content_notify = """NOTIFY * HTTP/1.1\r\n
HOST: 239.255.255.250:1900\r\n
CACHE-CONTROL: max-age = 1800\r\n
LOCATION: \r\n
NT: \r\n
NTS: ssdp:alive\r\n
SERVER:\r\n
USN: uuid:device-UUID::upnp:rootdevice\r\n
"""

msg_send_notify_twonkyvision = """NOTIFY * HTTP/1.0\r\n
HOST: 239.255.255.250:1900\r\n
CACHE-CONTROL: max-age=1810\r\n
LOCATION: http://10.1.1.1:9000/DeviceDescription.xml\r\n
NT: urn:schemas-upnp-org:service:ContentDirectory:1\r\n
NTS: ssdp:alive\r\n
SERVER: Linux/2.x.x, UPnP/1.0, TwonkyVision UPnP SDK/1.0\r\n
USN: uuid:896659847466-00-11-43-07-42-72-737837::urn:schemas-upnp-org:service:ContentDirectory:1\r\n
\r\n
"""

msearch_IGD_response = "HTTP/1.1 200 OK\r\n\
Cache-Control: max-age = 1800\r\n\
EXT: \r\n\
Location: http://10.1.1.1:9000/DeviceDescription.xml\r\n\
ST: urn:schemas-upnp-org:service:ContentDirectory:1\r\n\
Server: Testing Linux 2.6.12-1-686 UPnP/1.0 CyberLinkC/1.0\r\n\
USN: uuid:device-UUID::upnp:rootdevice\r\n\
\r\n\
\r\n"

msmm = "NOTIFY * HTTP/1.0"

def send_tcp_message(server, textport, message):
    port = 0
    try:
        s = socket.socket()
    except socket.error, e:
        print "Strange error creating socket: %s" % e
        sys.exit(1)
    
    try:
        port = int(textport)
    except ValueError, e:       
        print "Invalid port number: %s" % e
        sys.exit(1)
    
    try:
        #print "server %s, port = %d\n" % (server, port)
        s.connect( (server, port) )
        s.send( message )
    except socket.error, e:
        print "Error sending data: %s" % e
        sys.exit(1)
        
    #print "Looking for replies..."
    received = False
    while received == False:
        buf = ""
        try:
            (buf, address) = s.recvfrom( 2048 )
        except socket.error, e:
            print "Error receiving data: %s" % e
            # do not brake, just show a message and skip
            sys.exit(1)
        if not len(buf):
            continue
        else:
            received = True
        #print "Response received from %s: %s" % (address, buf)   
    
    try:
        #print "Closing socket (%s, %s)\n" % (server, port)
        s.close()
    except socket.error, e:
        print "Error sending data: %s" % e
        #sys.exit(1)
