#!/usr/bin/python

#doc: Sends some NOTIFY advertisement messages with packet size bigger than 512 bytes
#Test Type: Stress testing
#Test ID: 1.2
#Description: This try to send some NOTIFY advertisement messages that are bigger than the ones 
#        expected by UPnP standard (that have at most 512 bytes).

from test import start, finish, host
from stress.notify_sender import UDPSendMsgSession
import sys

notify_type = 'notify_ssdp_alive_big'

# max number of NOTIFYs
max_notify_number = 100

port = 38400

p = start('igd_cp', 1)

udp_send_msgs_session = UDPSendMsgSession()
udp_send_msgs_session.send_notify_message_from_file(notify_type, max_notify_number, host)

sys.exit(finish(p))
